import * as ui from 'mojang-minecraft-ui'
import { world } from 'mojang-minecraft'
import * as trans from './translations.js'

let mainMenu = new ui.ActionFormData()
.title("Bible addon 1.0.0")
//.button("Quick search", "textures/ui/magnifyingGlass.png")
.button("New testament")
.button("Old testament")
.button("Select Translation")

let NT = new ui.ActionFormData()
.title("Select Book")

let OT = new ui.ActionFormData()
.title("Select book")

let verse = new ui.ActionFormData()
verse.button("Next chapter", "textures/ui/arrow_r_default.png")
verse.button("Previous chapter", "textures/ui/arrow_l_default.png")
verse.button("Back", "textures/ui/book_metatag_default.png")
//verse.button("Translator Notes", "textures/ui/comment.png")
var prevBook = "NA"
var prevNum = 1
var Translation = "trans.en_KJV"
var OTbuilt = false
var NTbuilt = false
var TrSelection = 0
function MainMenu(player){
    mainMenu.show(player).then((r) => { 
        if (r.canceled) {return}
        /*if(r.selection == 0){
            VrsSearch(player)
        }*/
        if(r.selection ==0)
        {
            NewTestament(player)
        }
        if(r.selection == 1)
        {
            OldTestament(player)
        }
        if (r.selection == 2)
        {
            ChangeTr(player)
            console.warn(TrSelection)
        }
    })
}
function ChangeTr(player){
    let trFORM = new ui.ModalFormData()
    .title(eval(Translation).DisplayTexts[4])
    .dropdown("Translation", trans.list, 0)
    trFORM.show(player).then(e => {
        Translation = "trans." + trans.translations[e.formValues]
        TrSelection = e.formValues
        OTbuilt = false
        NTbuilt = false
        mainMenu = new ui.ActionFormData()
    .title(eval(Translation).DisplayTexts[0])
    .button(eval(Translation).DisplayTexts[1])
    .button(eval(Translation).DisplayTexts[2])
    .button(eval(Translation).DisplayTexts[3])

    NT = new ui.ActionFormData()
    .title(eval(Translation).DisplayTexts[5])

    OT = new ui.ActionFormData()
    .title(eval(Translation).DisplayTexts[5])

    verse = new ui.ActionFormData()
    verse.button(eval(Translation).DisplayTexts[7], "textures/ui/arrow_r_default.png")
    verse.button(eval(Translation).DisplayTexts[8], "textures/ui/arrow_l_default.png")
    verse.button(eval(Translation).DisplayTexts[9], "textures/ui/book_metatag_default.png")

        MainMenu(player)
    })
    

}
function OldTestament(player){
    if(!OTbuilt){
    for (var c = 0; c < eval(Translation).OTBooks.length; c++){
        let bookTitle = eval(Translation).OTBooks[c].replace("_", " ")
        bookTitle = bookTitle.replace("_", " ")
    OT.button(bookTitle)
    }
}
    OTbuilt = true
    OT.show(player).then((r) => { if (r.canceled) {return}

    Chapter(player, eval(Translation).OTBooks[r.selection])
})
}
function NewTestament(player) {
    if (!NTbuilt){
    for (var c = 0; c < eval(Translation).NTBooks.length; c++){
        let bookTitle = eval(Translation).NTBooks[c].replace("_", " ")
        bookTitle = bookTitle.replace("_", " ")
    NT.button(bookTitle)
    }}
    NTbuilt =true
    NT.show(player).then((r) => { if (r.canceled) {return}

        Chapter(player, eval(Translation).NTBooks[r.selection])
    })
}

function Chapter(player, book) {
    let chapter = new ui.ModalFormData()
        chapter.title(eval(Translation).DisplayTexts[6])
    eval("chapter.slider('chapter', 1, "+Translation+"." + book+".length, 1, 1)")
    chapter.show(player).then((result) => {
        let foot = result.formValues[0]
        console.warn(result.formValues)
      
    Verse(player, book, foot)
        
 })
}

function Verse(player, book, chapterNum) {

    if (book != "no"){ 
        
        let bookTitle = book.replace("_", " ")
        bookTitle = bookTitle.replace("_", " ")
        eval("verse.title('"+bookTitle+" ' + [chapterNum].toString())")
        eval("verse.body("+Translation+"."+book+"[chapterNum - 1])") 
        prevBook = book
        prevNum = chapterNum}
    
    
    verse.show(player).then((result) => { 
        if(result.selection == 0){
            Verse(player, book, chapterNum + 1)
            
        }
        if(result.selection == 1){
            Verse(player, book, chapterNum - 1) 
                
        }
        if (result.selection == 2) {
            MainMenu(player)
        }
        
    })
}
function StartRedirect(player){
    if (prevBook == "NA"){
        MainMenu(player)
    }
    else{
        Verse(player, prevBook, prevNum)
    }
}
world.events.beforeItemUse.subscribe(eventData => {
    let player = eventData.source
    let item = eventData.item
    if (item.id == "minecraft:book" && item.nameTag == "Bible") {
        if(player.isSneaking){
        MainMenu(player)
        }
        else{
            StartRedirect(player)
        }


    }    
    })

